void initSerial() {
  // Set SPI for serial interface with DDS chip and DAC
  SPI.begin();// SPI commands are setup but are not used
  SPI.setClockDivider(84);// Defines SPI clock frequency relative to master XTAL
  
  // Initialize the serial communications to the computer.
  SerialUSB.begin(115200);
  stimInterface.setDataHandler(&evaluateEEGcommand);
  stimInterface.begin(&Serial3, 115200);
}

void initPins() {
  // initialize power supply 
  pinMode(PS22Ven, OUTPUT);
  digitalWrite(PS22Ven, HIGH);  
  
  // initialize DACs  
  pinMode(DACen, OUTPUT);
  digitalWrite(DACen, HIGH);

  // Set trigger output pin.
  pinMode(triggerPin, OUTPUT);
  digitalWrite(triggerPin, LOW);
  
  // Set pins to select waveform source  
  pinMode(WfmSrcSel0A0, OUTPUT);
  pinMode(WfmSrcSel0A1, OUTPUT);
  pinMode(WfmSrcSel0A2, OUTPUT);
  pinMode(WfmSrcSel1A0, OUTPUT);
  pinMode(WfmSrcSel1A1, OUTPUT);
  pinMode(WfmSrcSel1A2, OUTPUT);
  pinMode(WfmSrcSelArdLtch, OUTPUT);
  pinMode(WfmSrcSelLtchSel, OUTPUT);
  digitalWrite(WfmSrcSel0A0, LOW);  
  digitalWrite(WfmSrcSel0A1, LOW);    
  digitalWrite(WfmSrcSel0A2, LOW);    
  digitalWrite(WfmSrcSel1A0, LOW);    
  digitalWrite(WfmSrcSel1A1, LOW);    
  digitalWrite(WfmSrcSel1A2, LOW);
  digitalWrite(WfmSrcSelArdLtch, LOW);
  digitalWrite(WfmSrcSelLtchSel, LOW);
  
  // Set pins to interface with multiplexer
  pinMode(SDATA1, OUTPUT);
  pinMode(RCK1, OUTPUT);
  pinMode(SCK1, OUTPUT);
  pinMode(SCLR1, OUTPUT);
  
  // Set pins to interface with MDAC0 and MDAC1
  pinMode(MDAC0CS, OUTPUT);
  pinMode(MDAC1CS, OUTPUT);
  digitalWrite(MDAC0CS, HIGH);
  digitalWrite(MDAC1CS, HIGH);

  // Set pins to interface with DDS chip
  pinMode(DDS0Fsync, OUTPUT);
  pinMode(DDS1Fsync, OUTPUT);
  pinMode(DDSPhaseSel, OUTPUT);
  pinMode(DDSFreqSel, OUTPUT);
  pinMode(DDSSleep, OUTPUT);  
  pinMode(DDSsourceReset, OUTPUT);
  pinMode(DDSphaseReset, OUTPUT);  
  digitalWrite(DDSphaseReset, LOW);  
    // below 4 added 150711 dcb
  digitalWrite(DDSSleep, LOW);
  digitalWrite(DDSsourceReset, LOW);
  digitalWrite(DDSPhaseSel, LOW);
  digitalWrite(DDSFreqSel, LOW);
  pinMode(DDS0MSB, INPUT);
  pinMode(DDS1MSB, INPUT);
}

void initAnalog() {
  analogReadResolution(16);
//  pinMode(A0, INPUT);
//  pinMode(A1, INPUT);
//  pinMode(A4, INPUT);
//  pinMode(A5, INPUT);
}
