#define SynchronizeWSS() digitalWrite(WfmSrcSelLtchSel, LOW)
#define Pin44Trigger() digitalWrite(WfmSrcSelLtchSel, HIGH); digitalWrite(WfmSrcSelArdLtch, LOW); digitalWrite(WfmSrcSelArdLtch, HIGH); digitalWrite(WfmSrcSelArdLtch, LOW)

unsigned short DDSout2; //= 0x43; //Freq Register Upper LSBs (0x5A)
unsigned short DDSout1; //= 0xE8; //Freq Register Lower LSBs (0x00)
unsigned short DDSout4; //= 0x40; //Freq Register Upper MSBs (0x40)
unsigned short DDSout3; //= 0x00; //Freq Register Lower MSBs  (0x00)

float savedEEGWfm0Current = 0;
float savedEEGWfm1Current = 0;
float currEEGWfm0Current = 0;
float currEEGWfm1Current = 0;
enum stimulationstate savedEEGSimState = RUN;
boolean firstEEGCommand = false;
unsigned long startms = 0;

void evaluateEEGcommand (float freq_, float amp_, float phase_) {
//  SerialUSB.print("frq: " + String(freq_));
//  SerialUSB.print(" amp: " + String(amp_));
//  SerialUSB.print(" phs: " + String(phase_));
//  SerialUSB.println();

  if(firstEEGCommand){
    firstEEGCommand = false;
    startms = millis();
    savedEEGSimState = stimulationstate;
  }
  
  unsigned long elapsedms = millis()-startms;
  double elapseds = elapsedms/1000.0;
  double phase = phase_+PI; // 2*PI*freq_*elapseds + 
  double unity_wave = 0.5+cos(phase)/2.0; // the amplitude ranges from 0 to 1

//  SerialUSB.println("stimulationstate: "+String(stimulationstate));
//  SerialUSB.println("Wfm0Current: "+String(Wfm0Current));
//  SerialUSB.println("Wfm1Current: "+String(Wfm1Current));

  if(stimulationstate != savedEEGSimState){
    savedEEGSimState = stimulationstate;
    if ((stimulationstate == RUN) or (stimulationstate == DEBUG)) {
      savedEEGWfm0Current = Wfm0Current;
      savedEEGWfm1Current = Wfm1Current;
    }else{
      savedEEGWfm0Current = Wfm0Save;
      savedEEGWfm1Current = Wfm1Save;
    }
  }else{
    if ((stimulationstate == RUN) or (stimulationstate == DEBUG)) {
      if(Wfm0Current != currEEGWfm0Current){
        savedEEGWfm0Current = Wfm0Current;
      }
      if(Wfm1Current != currEEGWfm1Current){
        savedEEGWfm1Current = Wfm1Current;
      }
    }else{
      if(Wfm0Save != currEEGWfm0Current){
        savedEEGWfm0Current = Wfm0Save;
      }
      if(Wfm1Save != currEEGWfm1Current){
        savedEEGWfm1Current = Wfm1Save;
      }
    }
  }

  currEEGWfm0Current = unity_wave * savedEEGWfm0Current;
  currEEGWfm1Current = unity_wave * savedEEGWfm1Current;
  SetMDAC0(currEEGWfm0Current);
  SetMDAC1(currEEGWfm1Current);
}


double wrapTo360(double phase){
  phase = fmod(phase,360.0);
  if(phase<0){
    phase = 360+phase;
  }
  return phase;
}

void evaluatecommand(String commandstring) {
  // Test the String for commands.

  if (commandstring.substring(0, 10) == "PhaseShift") {
    commandstring = commandstring.substring(11);
    
    if (commandstring.substring(0, 2) == "0 ") {
      commandstring = commandstring.substring(3); // Remove Channel from string
      float phaseshift = strtof(commandstring.c_str(), NULL);
      float startperiod = 1/currentDDS0freq;
      float shiftperiod = (1+phaseshift/360)*startperiod;
      unsigned long stoptime = micros() + shiftperiod*1000000;
      SetDDS0freq(1/shiftperiod);
      while (micros() < stoptime);
      SetDDS0freq(currentDDS0freq);
    }
    else if (commandstring.substring(0, 2) == "1 ") {
      commandstring = commandstring.substring(3); // Remove Channel from string
      float phaseshift = strtof(commandstring.c_str(), NULL);
      float startperiod = 1/currentDDS1freq;
      float shiftperiod = (1+phaseshift/360)*startperiod;
      unsigned long stoptime = micros() + shiftperiod*1000000;
      SetDDS1freq(1/shiftperiod);
      while (micros() < stoptime);
      SetDDS1freq(currentDDS0freq);
    }
  }

  if (commandstring.substring(0, 7) == "EEGLock") {
    commandstring = commandstring.substring(8);
    int spaceIndex1 = commandstring.indexOf(' ');
//    int spaceIndex2 = commandstring.indexOf(' ', spaceIndex1 + 1);
    
    // Get the specified carrier frequency and configure to lock using EEG data.
    int isactive = atoi(commandstring.substring(0, spaceIndex1).c_str());
//    float carrierfreq = strtof(commandstring.substring(spaceIndex1 + 1, spaceIndex2).c_str(), NULL);
//    float beatfreq = strtof(commandstring.substring(spaceIndex2 + 1).c_str(), NULL);

//    SerialUSB.print("EEGLock ");
//    SerialUSB.print(isactive);
//    SerialUSB.print(",");
//    SerialUSB.print(carrierfreq);
//    SerialUSB.print(",");
//    SerialUSB.print(beatfreq);
//    SerialUSB.println();

    if (isactive == 0) EEGLockingFlag = false;
    else if (isactive == 1) {
      EEGLockingFlag = true;

      // With the EEGLockingFlag set true, the system will listen to the UART for updates to the
      // target beat frequency and target phase of the beat which is given by \phi_1 - \phi_2. This
      // is handled in the main loop if EEGLockingFlag is set, so here we just set up the starting
      // signal.
      
//      SetDDS0freq(carrierfreq);
//      SetDDS1freq(carrierfreq + beatfreq);
//      SetDDS0phase(0);
//      SetDDS1phase(0);
      DDSReset();
      firstEEGCommand = true;
    }
  }
  

  if (commandstring.substring(0, 17) == "StimulationAddRow") { // Add a row to the stimulation table.
    // Need to get the arguments to the function split up into discrete cells to access.
    commandstring = commandstring.substring(18);
    int spaceIndex1 = commandstring.indexOf(' '); // Find the first remaining space.
    int spaceIndex2 = commandstring.indexOf(' ', spaceIndex1 + 1); // Second space.
    int spaceIndex3 = commandstring.indexOf(' ', spaceIndex2 + 1); // Second space.
    int spaceIndex4 = commandstring.indexOf(' ', spaceIndex3 + 1); // Second space.
    int spaceIndex5 = commandstring.indexOf(' ', spaceIndex4 + 1); // Second space.
    int spaceIndex6 = commandstring.indexOf(' ', spaceIndex5 + 1); // Second space.
    int spaceIndex7 = commandstring.indexOf(' ', spaceIndex6 + 1); // Second space.
    int spaceIndex8 = commandstring.indexOf(' ', spaceIndex7 + 1); // Second space.
    int spaceIndex9 = commandstring.indexOf(' ', spaceIndex8 + 1); // Second space.
    int spaceIndex10 = commandstring.indexOf(' ', spaceIndex9 + 1); // Second space.
    int spaceIndex11 = commandstring.indexOf(' ', spaceIndex10 + 1); // Second space.
    int spaceIndex12 = commandstring.indexOf(' ', spaceIndex11 + 1); // Second space.
    int spaceIndex13 = commandstring.indexOf(' ', spaceIndex12 + 1); // Second space.
    int spaceIndex14 = commandstring.indexOf(' ', spaceIndex13 + 1); // Second space.
    int spaceIndex15 = commandstring.indexOf(' ', spaceIndex14 + 1); // Second space.
    int spaceIndex16 = commandstring.indexOf(' ', spaceIndex15 + 1); // Second space.
    int spaceIndex17 = commandstring.indexOf(' ', spaceIndex16 + 1); // Second space.
    int spaceIndex18 = commandstring.indexOf(' ', spaceIndex17 + 1); // Second space.
    int spaceIndex19 = commandstring.indexOf(' ', spaceIndex18 + 1); // Second space.
    int spaceIndex20 = commandstring.indexOf(' ', spaceIndex19 + 1);
    
    stimulationrow newrow; // Define a new row using our structure.
    newrow.preidletime = strtof(commandstring.substring(0, spaceIndex1).c_str(), NULL);
    newrow.rampuptime = strtof(commandstring.substring(spaceIndex1 + 1, spaceIndex2).c_str(), NULL);
    newrow.duration = strtof(commandstring.substring(spaceIndex2 + 1, spaceIndex3).c_str(), NULL);
    newrow.rampdowntime = strtof(commandstring.substring(spaceIndex3 + 1, spaceIndex4).c_str(), NULL);
    newrow.postidletime = strtof(commandstring.substring(spaceIndex4 + 1, spaceIndex5).c_str(), NULL);
    newrow.freq0 = strtof(commandstring.substring(spaceIndex5 + 1, spaceIndex6).c_str(), NULL);
    newrow.amp0 = strtof(commandstring.substring(spaceIndex6 + 1, spaceIndex7).c_str(), NULL);
    newrow.offset0 = strtof(commandstring.substring(spaceIndex7 + 1, spaceIndex8).c_str(), NULL);
    newrow.ch1load = atoi(commandstring.substring(spaceIndex8 + 1, spaceIndex9).c_str());
    newrow.ch1pin = atoi(commandstring.substring(spaceIndex9 + 1, spaceIndex10).c_str());
    newrow.ch2load = atoi(commandstring.substring(spaceIndex10 + 1, spaceIndex11).c_str());
    newrow.ch2pin = atoi(commandstring.substring(spaceIndex11 + 1, spaceIndex12).c_str());
    newrow.freq1 = strtof(commandstring.substring(spaceIndex12 + 1, spaceIndex13).c_str(), NULL);
    newrow.amp1 = strtof(commandstring.substring(spaceIndex13 + 1, spaceIndex14).c_str(), NULL);
    newrow.offset1 = strtof(commandstring.substring(spaceIndex14 + 1, spaceIndex15).c_str(), NULL);
    newrow.ch3load = atoi(commandstring.substring(spaceIndex15 + 1, spaceIndex16).c_str());
    newrow.ch3pin = atoi(commandstring.substring(spaceIndex16 + 1, spaceIndex17).c_str());
    newrow.ch4load = atoi(commandstring.substring(spaceIndex17 + 1, spaceIndex18).c_str());
    newrow.ch4pin = atoi(commandstring.substring(spaceIndex18 + 1, spaceIndex19).c_str());
    newrow.trigger = atoi(commandstring.substring(spaceIndex19 + 1, spaceIndex20).c_str());
    newrow.chconfig = atoi(commandstring.substring(spaceIndex20 + 1).c_str());

    stimulationtable.push_back(newrow); // Add this new row to the stimulation table.

    // Print back the received data for verification.
//    SerialUSB.println("Received New Table Row");
//    SerialUSB.println("");
//    SerialUSB.println("Pre-Idle Time: " + String(newrow.preidletime));
//    SerialUSB.println("Ramp Up Time: " + String(newrow.rampuptime));
//    SerialUSB.println("Duration: " + String(newrow.duration));
//    SerialUSB.println("Ramp Down Time: " + String(newrow.rampdowntime));
//    SerialUSB.println("Post-Idle Time: " + String(newrow.postidletime));
//    SerialUSB.println("DDS0 Frequency: " + String(newrow.freq0));
//    SerialUSB.println("DDS0 Current: " + String(newrow.amp0));
//    SerialUSB.println("Offset 0: " + String(newrow.offset0));
//    SerialUSB.println("Ch1 Load: 0b" + String(newrow.ch1load, BIN));
//    SerialUSB.println("Ch1 Electrode: " + String(newrow.ch1pin, DEC));
//    SerialUSB.println("Ch2 Load: 0b" + String(newrow.ch2load, BIN));
//    SerialUSB.println("Ch2 Electrode: " + String(newrow.ch2pin, DEC));
//    SerialUSB.println("DDS1 Frequency: " + String(newrow.freq1));
//    SerialUSB.println("DDS1 Current: " + String(newrow.amp1));
//    SerialUSB.println("Offset 1: " + String(newrow.offset1));
//    SerialUSB.println("Ch3 Load: 0b" + String(newrow.ch3load, BIN));
//    SerialUSB.println("Ch3 Electrode: " + String(newrow.ch3pin, DEC));
//    SerialUSB.println("Ch4 Load: 0b" + String(newrow.ch4load, BIN));
//    SerialUSB.println("Ch4 Electrode: " + String(newrow.ch4pin, DEC));
//    SerialUSB.println("Trigger: " + String(newrow.trigger, DEC));
  }

  if (commandstring.substring(0, 21) == "StimulationTableClear") { // Clear the current stimulation table.
    stimulationtable.clear(); // Delete all data in the current program table.
    //SerialUSB.println("SUCCESS: Current Stimulation Table cleared.");
  }

  if (commandstring.substring(0, 19) == "StimulationTableRun") { // Start running the Stimulation Table from the top.
    if (stimulationtable.size() > 0) { // Only if there is actually data in the table.
      stimulationstepstarttime = micros(); // Store the absolute start time for stimulation to calculate timing against.
      stimulationrownum = 0; // Set the stimulation row to the first one.
      stimulationrunning = true; // Tell the system that stimulation is active.
      stimulationtablestate = SETUP; // Enter setup mode in the table reading.
    }
    //else SerialUSB.println("ERROR: There is no data in stimulation program.");
  }

  if (commandstring.substring(0, 16) == "StimulationAbort") { // Halt the stimulation program.
    stimulationrunning = false; // Deactivate Stimulation.
    SetMDAC0(0); // Turn off both output DACs.
    SetMDAC1(0);
    SetChLoad(1, 0b0010); // Connect Channel Loads to the 10k resistor, disconnect from electrodes.
    SetChLoad(2, 0b0010);
    SetChLoad(3, 0b0010);
    SetChLoad(4, 0b0010);
  }

  if (commandstring.substring(0, 5) == "Pulse") {
    commandstring = commandstring.substring(6);
    int spaceIndex1 = commandstring.indexOf(' '); // Finds the first remaining space.
    int spaceIndex2 = commandstring.indexOf(' ', spaceIndex1 + 1); // Finds the second.
    int spaceIndex3 = commandstring.indexOf(' ', spaceIndex2 + 1); // Finds the third.
    int spaceIndex4 = commandstring.indexOf(' ', spaceIndex3 + 1); // Finds the fourth.
    int spaceIndex5 = commandstring.indexOf(' ', spaceIndex4 + 1); // Finds the fifth.
    int highperiod = atoi(commandstring.substring(0, spaceIndex1).c_str()); // Capture period of high pulse.
    int lowperiod = atoi(commandstring.substring(spaceIndex1 + 1, spaceIndex2).c_str()); // Capture period of low pulse.
    float highcurrent = strtof(commandstring.substring(spaceIndex2 + 1, spaceIndex3).c_str(), NULL); // Capture current of high pulse.
    float lowcurrent = strtof(commandstring.substring(spaceIndex3 + 1, spaceIndex4).c_str(), NULL); // Capture current of low pulse.
    int totalperiod = atoi(commandstring.substring(spaceIndex4 + 1, spaceIndex5).c_str()); // Capture total period.
    int repetitions = atoi(commandstring.substring(spaceIndex5 + 1).c_str()); // Captures number of pulse repeats.
    RunPulse(highperiod, lowperiod, highcurrent, lowcurrent, totalperiod, repetitions);
  }

  // This starts the section for Stimulation Program Running.
  if (commandstring.substring(0, 11) == "SetModeSafe") {
    SetModeSafe();
  }

  if (commandstring.substring(0, 12) == "SetTriggerOn") {
    digitalWrite(triggerPin, HIGH);
  }

  if (commandstring.substring(0, 13) == "SetTriggerOff") {
    digitalWrite(triggerPin, LOW);
  }

  if (commandstring.substring(0, 12) == "SetModeDebug") {
    SetModeDebug();
  }

  if (commandstring.substring(0, 10) == "SetModeRun") {
    SetModeRun();
  }

  if (commandstring.substring(0, 9) == "Stimulate") {
    commandstring = commandstring.substring(10);
    int endtime = atoi(commandstring.c_str()) + millis(); // Calculate end time.
    enum stimulationstate stimulationstatesave = stimulationstate;
    SetModeRun();
    while (millis() < endtime); // Wait for Run Period.
    if (stimulationstatesave == RUN); // Do nothing because it is already running.
    else if (stimulationstatesave == SAFE) SetModeSafe(); // Go back to Safe.
    else if (stimulationstatesave == DEBUG) SetModeDebug(); // Go back to Debug.
  }

  // This starts the section for the ADC.
  // Currently this simply sends 4000 8-bit values in byte format.
  if (commandstring.substring(0, 7) == "ADCRead") {
    unsigned int analogvalue0, analogvalue1, analogvalue4, analogvalue5;
    commandstring = commandstring.substring(7); // Erase ADC0Read and space.
    int ADCdelay = (int)strtof(commandstring.c_str(), NULL);
    uint8_t analog[32000];
    for (int i = 0; i < 32000; i = i + 8) {
      analogvalue0 = analogRead(0);
      analogvalue1 = analogRead(1);
      analogvalue4 = analogRead(4);
      analogvalue5 = analogRead(5);
      analog[i] = (analogvalue0 >> 8) & 0xFF;
      analog[i + 1] = analogvalue0 & 0xFF;
      analog[i + 2] = (analogvalue1 >> 8) & 0xFF;
      analog[i + 3] = analogvalue1 & 0xFF;
      analog[i + 4] = (analogvalue4 >> 8) & 0xFF;
      analog[i + 5] = analogvalue4 & 0xFF;
      analog[i + 6] = (analogvalue5 >> 8) & 0xFF;
      analog[i + 7] = analogvalue5 & 0xFF;
      delayMicroseconds(ADCdelay);
    }
    SerialUSB.write(analog, 32000);
  }

  // Streams ADC values at all times.
  if (commandstring.substring(0, 9) == "ADCStream") {
    SerialUSB.println("Test");
    commandstring = commandstring.substring(10);
    if (commandstring = "ON") {
      streamingFlag = 1;
      lastmicros = micros();
    }
    else if (commandstring = "OFF") {
      streamingFlag = 0;
    }
    else {
      SerialUSB.println("Invalid Command, ADCStream expects ON or OFF as arguments.");
    }
  }

  if (commandstring.substring(0, 7) = "ADCSync") {
    delay(10);
  }

  // Reads Diagnostic Signals
  if (commandstring == "ReadDiagnosticSignals") {
    float voltage22plus, voltage22minus, voltagebattery, voltage165;
    voltage22plus = (float)analogRead(8) * 3.3 / 0xFFFF * 21.0;
    voltage22minus = (float)analogRead(9) * 3.3 / 0xFFFF * 21.0 - 66.0;
    voltagebattery = (float)analogRead(10) * 3.3 / 0xFFFF * 10.0;
    voltage165 = (float)analogRead(11) * 3.3 / 0xFFFF;
    SerialUSB.println("+22V: " + String(voltage22plus));
    SerialUSB.println("-22V: " + String(voltage22minus));
    SerialUSB.println("Battery: " + String(voltagebattery));
    SerialUSB.println("1.65V: " + String(voltage165));
  }

  // This starts the section for the DAC.

  if (commandstring.substring(0, 4) == "DAC ") { // Check for "DAC " (including space)
    commandstring = commandstring.substring(4); // Erase "DAC " from string
    String channel = commandstring.substring(0, 1);
    commandstring = commandstring.substring(2);
    SetDAC(channel, strtof(commandstring.c_str(), NULL));
  }

  // This ends the section for the DAC.
  // *******************************************************
  // This starts the section for the DDS.
  else if (commandstring.substring(0, 4) == "DDS ") { // Check for "DDS " (including space)
    commandstring = commandstring.substring(4); // Erase "DDS " from string
    if (commandstring.substring(0, 2) == "0 ") {
      commandstring = commandstring.substring(2); // Remove Channel from string
      commandstringDDS0 = commandstring;
      SetDDS0freq(strtof(commandstringDDS0.c_str(), NULL));
    }
    else if (commandstring.substring(0, 2) == "1 ") {
      commandstring = commandstring.substring(2); // Remove Channel from string
      commandstringDDS1 = commandstring;
      SetDDS1freq(strtof(commandstringDDS1.c_str(), NULL));
    }
    DDSReset();
  }

  // This ends the section for the DDS.
  // *********************************************************
  // This starts the section for the waveform source selector.

  if (commandstring.substring(0, 4) == "WSS ") { // Check for "WSS " (including space)
    commandstring = commandstring.substring(4); // Erase "WSS " from string
    if (commandstring.substring(0, 2) == "0 " or commandstring.substring(0, 2) == "1 ") {
      byte channel = atoi(commandstring.substring(0, 2).c_str());
      commandstring = commandstring.substring(2);
      // Set the WSS based on the channel and output selected.
      SetWSS(channel, commandstring);
    }
    else if (commandstring == "S") { // Synchronize WSS
      SynchronizeWSS();
    }
    else if (commandstring == "T") { // Set Pin 44 as Trigger Source
      Pin44Trigger();
    }
  }

  // This ends the section for the waveform source selector.
  // *********************************************************
  // This starts the section for the multiplexer.

  if (commandstring.substring(0, 9) == "ChConfig ") { // Check for "ChConfig " (including space)
    unsigned char NewChConfig[8]; // An 8 int wide array of values (Ch1-4 Load, Ch1-4 Pin)
    commandstring = commandstring.substring(9);
    for (char i = 0; i < 8; i++) {
      // Each time through, assume a two digit int (00-99) followed by a space.
      NewChConfig[i] = atoi(commandstring.substring(0, 2).c_str());
      // First capture the value and convert to an int.
      commandstring = commandstring.substring(3);
      // Then delete the three characters for the two int chars plus the space.
    }
    // SetChConfig expects an 8 unsigned char array of configuration values.
    SetChConfig(NewChConfig);

    lcd2.setCursor(0, 0);
    lcd2.print("CH1: ");
    if ((NewChConfig[4]+1)  < 10) lcd2.print("0");
    lcd2.print((NewChConfig[4]+1));
    lcd2.print("   CH2: ");
    if ((NewChConfig[5]+1)  < 10) lcd2.print("0");
    lcd2.print((NewChConfig[5]+1));
    lcd2.print("   CH3: ");
    if ((NewChConfig[6]+1)  < 10) lcd2.print("0");
    lcd2.print((NewChConfig[6]+1));
    lcd2.print("   CH4: ");
    if ((NewChConfig[7]+1)  < 10) lcd2.print("0");
    lcd2.print((NewChConfig[7]+1));
    lcd2.setCursor(0, 1);
//    lcd2.print("");
    lcd2.print(LoadName[NewChConfig[0]]);
    lcd2.print("   ");
    lcd2.print(LoadName[NewChConfig[1]]);
    lcd2.print("   ");
    lcd2.print(LoadName[NewChConfig[2]]);
    lcd2.print("   ");
    lcd2.print(LoadName[NewChConfig[3]]);
  }

  // This is the load configuration for the multiplexer.

  if (commandstring.substring(0, 7) == "ChLoad ") { // Check for "ChLoad "
    commandstring = commandstring.substring(7);
    char channel = atoi(commandstring.substring(0, 1).c_str());
    commandstring = commandstring.substring(2);
    SetChLoad(channel, atoi(commandstring.c_str()));
  }

  // These are four redundant commands for setting load options.

  if (commandstring.substring(0, 7) == "Ch1Load") { // Check for "Ch1Load"
    commandstring = commandstring.substring(8);
    SetChLoad(1, atoi(commandstring.c_str()));
  }

  if (commandstring.substring(0, 7) == "Ch2Load") { // Check for "Ch2Load"
    commandstring = commandstring.substring(8);
    SetChLoad(2, atoi(commandstring.c_str()));
  }

  if (commandstring.substring(0, 7) == "Ch3Load") { // Check for "Ch3Load"
    commandstring = commandstring.substring(8);
    SetChLoad(3, atoi(commandstring.c_str()));
  }

  if (commandstring.substring(0, 7) == "Ch4Load") { // Check for "Ch4Load"
    commandstring = commandstring.substring(8);
    SetChLoad(4, atoi(commandstring.c_str()));
  }

  // This is the electrode configuration for the multiplexer.

  if (commandstring.substring(0, 6) == "ChPin ") { // Check for "ChPin "
    commandstring = commandstring.substring(6);
    char channel = atoi(commandstring.substring(0, 1).c_str());
    commandstring = commandstring.substring(2);
    SetChElectrode(channel, atoi(commandstring.c_str()));
  }

  // These are four redundant commands for setting electrode pins.

  if (commandstring.substring(0, 12) == "Ch1Electrode") {
    commandstring = commandstring.substring(13);
    SetChElectrode(1, atoi(commandstring.c_str()));
  }

  if (commandstring.substring(0, 12) == "Ch2Electrode") {
    commandstring = commandstring.substring(13);
    SetChElectrode(2, atoi(commandstring.c_str()));
  }

  if (commandstring.substring(0, 12) == "Ch3Electrode") {
    commandstring = commandstring.substring(13);
    SetChElectrode(3, atoi(commandstring.c_str()));
  }

  if (commandstring.substring(0, 12) == "Ch4Electrode") {
    commandstring = commandstring.substring(13);
    SetChElectrode(4, atoi(commandstring.c_str()));
  }

  // This ends the section for the multiplexer.
  // *********************************************************
  // This starts the section for the MDAC current scaling. For simplicity
  // in writing it quickly, I'm just defining two separate commands, one
  // for MDAC0 and one for MDAC1.

  if (commandstring.substring(0, 8) == "Wfm0 mA ") { // Check for the command to set scaling on MDAC0.
    commandstring = commandstring.substring(8);
    SetMDAC0(strtof(commandstring.c_str(), NULL));
  }

  if (commandstring.substring(0, 8) == "Wfm1 mA ") { // Check for the command to set scaling on MDAC0.
    commandstring = commandstring.substring(8);
    SetMDAC1(strtof(commandstring.c_str(), NULL));
  }

  // This starts the section for Ramping the MDAC current output.

  if (commandstring.substring(0, 11) == "RampWfm0 mA") { // Check for ramp command.
    commandstring = commandstring.substring(12);
    int spaceIndex1 = commandstring.indexOf(' '); // Finds the first remaining space.
    int spaceIndex2 = commandstring.indexOf(' ', spaceIndex1 + 1); // Finds the second.
    float startval = strtof(commandstring.substring(0, spaceIndex1).c_str(), NULL); // Captures first float.
    float endval = strtof(commandstring.substring(spaceIndex1 + 1, spaceIndex2).c_str(), NULL); // Captures second float.
    int period = atoi(commandstring.substring(spaceIndex2 + 1).c_str()); // Captures third int.
    RampMDAC(startval, endval, period, 0); // Ramp channel 0.
  }

  if (commandstring.substring(0, 11) == "RampWfm1 mA") { // Check for ramp command.
    commandstring = commandstring.substring(12);
    int spaceIndex1 = commandstring.indexOf(' '); // Finds the first remaining space.
    int spaceIndex2 = commandstring.indexOf(' ', spaceIndex1 + 1); // Finds the second.
    float startval = strtof(commandstring.substring(0, spaceIndex1).c_str(), NULL); // Captures first float.
    float endval = strtof(commandstring.substring(spaceIndex1 + 1, spaceIndex2).c_str(), NULL); // Captures second float.
    int period = atoi(commandstring.substring(spaceIndex2 + 1).c_str()); // Captures third int.
    RampMDAC(startval, endval, period, 1); // Ramp channel 1.
  }

  if (commandstring.substring(0, 10) == "RampWfm mA") { // Check for ramp command.
    commandstring = commandstring.substring(11);
    int spaceIndex1 = commandstring.indexOf(' '); // Finds the first remaining space.
    int spaceIndex2 = commandstring.indexOf(' ', spaceIndex1 + 1); // Finds the second.
    int spaceIndex3 = commandstring.indexOf(' ', spaceIndex2 + 1); // Finds the third.
    int spaceIndex4 = commandstring.indexOf(' ', spaceIndex3 + 1); // Finds the fourth.
    float startval0 = strtof(commandstring.substring(0, spaceIndex1).c_str(), NULL); // Captures first float.
    float endval0 = strtof(commandstring.substring(spaceIndex1 + 1, spaceIndex2).c_str(), NULL); // Captures second float.
    float startval1 = strtof(commandstring.substring(spaceIndex2 + 1, spaceIndex3).c_str(), NULL); // Captures third float.
    float endval1 = strtof(commandstring.substring(spaceIndex3 + 1, spaceIndex4).c_str(), NULL); // Captures fourth float.
    int period = atoi(commandstring.substring(spaceIndex4 + 1).c_str()); // Captures third int.
    SimultaneousRampMDAC(startval0, endval0, startval1, endval1, period);
  }
  // This ends the section for the MDAC current scaling.
}

void DDSReset(void) {
  digitalWrite(DDSphaseReset, HIGH);
  digitalWrite(DDSphaseReset, LOW);
}

void SetDDS0freq(float freq) {
  currentDDS0freq = freq;
  // Program DDS Mode, Frequency, Phase, and Reset OFF
  SPI.setDataMode(SPI_MODE2);
  CompDDSOut(freq); // calc. Byte output for DDS0
  float DDS0tempFreq = freq ;
  digitalWrite(DDS0Fsync, LOW); //Pull enable low to begin SPI communication
  SPI.transfer(0x23);    // 1st byte of control word sets freq to be sent in two bytes LSB first was 21
  SPI.transfer(0x00);    // 2nd byte of control word RESET phase to zero degrees (dac mid scale)
  SPI.transfer(DDSout2); // 8 higher bits of freq LSBs
  SPI.transfer(DDSout1); // 8 lower bits of freq LSBs
  SPI.transfer(DDSout4); // 8 higher bits of freq MSBs
  SPI.transfer(DDSout3); // 8 lower bits of freq MSBs
  SPI.transfer(0xC0);    // 1st byte of control word for Phase Register 0 to be zero
  SPI.transfer(0x00);    // 2nd byte of control word for Phase register to be zero
  SPI.transfer(0x22);    // 1st byte of control word to release Reset mode and start frequency was 20
  SPI.transfer(0x20);    // 2nd byte of control word to enable MSB/2 comparator pin on
  digitalWrite(DDS0Fsync, HIGH); //End communication
  lcd.setCursor(0, 0);
  lcd.print("Wfm 0 Hz: ");
  lcd.print(DDS0tempFreq);
}

void SetDDS1freq(float freq) {
  currentDDS1freq = freq;
  // Program DDS Mode, Frequency, Phase, and Reset OFF
  SPI.setDataMode(SPI_MODE2);
  CompDDSOut(freq); // calc. Byte output for DDS0
  float DDS1tempFreq = freq ;
  digitalWrite(DDS1Fsync, LOW); //Pull enable low to begin SPI communication
  SPI.transfer(0x23);    // 1st byte of control word sets freq to be sent in two bytes LSB first was 21
  SPI.transfer(0x00);    // 2nd byte of control word RESET phase to zero degrees (dac mid scale)
  SPI.transfer(DDSout2); // 8 higher bits of freq LSBs
  SPI.transfer(DDSout1); // 8 lower bits of freq LSBs
  SPI.transfer(DDSout4); // 8 higher bits of freq MSBs
  SPI.transfer(DDSout3); // 8 lower bits of freq MSBs
  SPI.transfer(0xC0);    // 1st byte of control word for Phase Register 0 to be zero
  SPI.transfer(0x00);    // 2nd byte of control word for Phase register to be zero
  SPI.transfer(0x22);    // 1st byte of control word to release Reset mode and start frequency was 20
  SPI.transfer(0x20);    // 2nd byte of control word to enable MSB/2 comparator pin on
  digitalWrite(DDS1Fsync, HIGH); //End communication
  lcd.setCursor(20, 0);
  lcd.print("Wfm 1 Hz: ");
  lcd.print(DDS1tempFreq);
}

// This function calcuates the DDS outputs based on a specified
// floating point frequency.

void CompDDSOut (float freq) {
  float DDSBitRes = pow(2, 28);
  float ClckFreq = 2.685000 * pow(10, 6); // Changed from 2.68465875 to compensate for crystal frequency not being ideal value dcb 150717
  int P1 = freq * DDSBitRes / ClckFreq;
  int Q1 = P1 / 16384;
  int R1 = P1 - 16384 * Q1;
  int Q2 = Q1 / 256;
  int R2 = Q1 - 256 * Q2;
  int Q3 = R1 / 256;
  int R3 = R1 - 256 * Q3;
  DDSout1 = R3;
  DDSout2 = Q3 + 64;
  DDSout3 = R2;
  DDSout4 = Q2 + 64;
}

void SetDDS0phase (float newphase) {
  SPI.setDataMode(SPI_MODE2);

  // Convert new phase into data.
  unsigned int DDSphase = (unsigned int)((fmod(newphase,360)/360)/4096); // Convert degrees to integer code.
    
  digitalWrite(DDS0Fsync, LOW);
  SPI.transfer(0b11000000 | ((DDSphase >> 4) & 0b00001111));
  SPI.transfer((DDSphase * 0b11111111));
  digitalWrite(DDS0Fsync, HIGH);
}

void SetDDS1phase (float newphase) {
  SPI.setDataMode(SPI_MODE2);

  // Convert new phase into data.
  unsigned int DDSphase = (unsigned int)((fmod(newphase,360)/360)/4096); // Convert degrees to integer code.
    
  digitalWrite(DDS1Fsync, LOW);
  SPI.transfer(0b11000000 | ((DDSphase >> 4) & 0b00001111));
  SPI.transfer((DDSphase * 0b11111111));
  digitalWrite(DDS1Fsync, HIGH);
}

// This function takes a channel (A-I) along with a float for the
// desired output voltage.

void SetDAC(String channel, float DACvolts) {
  digitalWrite(DACen, LOW); //Pull enable low to begin SPI communication
  if (channel == "A") SPI.transfer(0x30);
  else if (channel == "B") SPI.transfer(0x31);
  else if (channel == "C") SPI.transfer(0x32);
  else if (channel == "D") SPI.transfer(0x33);
  else if (channel == "E") SPI.transfer(0x34);
  else if (channel == "F") SPI.transfer(0x35);
  else if (channel == "G") SPI.transfer(0x36);
  else if (channel == "H") SPI.transfer(0x37);
  else if (channel == "I") SPI.transfer(0x3F); // All Channels
  DACvolts += 1.65; // Add offset to output voltage.
  int DACint = (DACvolts * 0xFFFF) / 3.3; // Scale to full 16-bit scale.

  // Configure SPI port for idle low, rising edge valid.

  SPI.setDataMode(SPI_MODE0); // SPI idle low, rising edge valid
  SPI.transfer(DACint >> 8);
  SPI.transfer(DACint & 0xFF);
  digitalWrite(DACen, HIGH); //End communication
}

void SetWSS(byte channel, String source) {
  if (channel == 0) {
    if (source == "DACA") {
      digitalWrite(WfmSrcSel0A0, LOW);
      digitalWrite(WfmSrcSel0A1, LOW);
      digitalWrite(WfmSrcSel0A2, LOW);
    }
    else if (source == "DACB") {
      digitalWrite(WfmSrcSel0A0, HIGH);
      digitalWrite(WfmSrcSel0A1, LOW);
      digitalWrite(WfmSrcSel0A2, LOW);
    }
    else if (source == "DACC") {
      digitalWrite(WfmSrcSel0A0, LOW);
      digitalWrite(WfmSrcSel0A1, HIGH);
      digitalWrite(WfmSrcSel0A2, LOW);
    }
    else if (source == "DACD") {
      digitalWrite(WfmSrcSel0A0, HIGH);
      digitalWrite(WfmSrcSel0A1, HIGH);
      digitalWrite(WfmSrcSel0A2, LOW);
    }
    else if (source == "SIN0") {
      digitalWrite(WfmSrcSel0A0, LOW);
      digitalWrite(WfmSrcSel0A1, LOW);
      digitalWrite(WfmSrcSel0A2, HIGH);
    }
    else if (source == "SIN1") {
      digitalWrite(WfmSrcSel0A0, HIGH);
      digitalWrite(WfmSrcSel0A1, LOW);
      digitalWrite(WfmSrcSel0A2, HIGH);
    }
    else if (source == "DAC0") {
      digitalWrite(WfmSrcSel0A0, LOW);
      digitalWrite(WfmSrcSel0A1, HIGH);
      digitalWrite(WfmSrcSel0A2, HIGH);
    }
    else if (source == "DAC1") {
      digitalWrite(WfmSrcSel0A0, HIGH);
      digitalWrite(WfmSrcSel0A1, HIGH);
      digitalWrite(WfmSrcSel0A2, HIGH);
    }
  }
  else if (channel == 1) {
    if (source == "DACA") {
      digitalWrite(WfmSrcSel1A0, LOW);
      digitalWrite(WfmSrcSel1A1, LOW);
      digitalWrite(WfmSrcSel1A2, LOW);
    }
    else if (source == "DACB") {
      digitalWrite(WfmSrcSel1A0, HIGH);
      digitalWrite(WfmSrcSel1A1, LOW);
      digitalWrite(WfmSrcSel1A2, LOW);
    }
    else if (source == "DACC") {
      digitalWrite(WfmSrcSel1A0, LOW);
      digitalWrite(WfmSrcSel1A1, HIGH);
      digitalWrite(WfmSrcSel1A2, LOW);
    }
    else if (source == "DACD") {
      digitalWrite(WfmSrcSel1A0, HIGH);
      digitalWrite(WfmSrcSel1A1, HIGH);
      digitalWrite(WfmSrcSel1A2, LOW);
    }
    else if (source == "SIN0") {
      digitalWrite(WfmSrcSel1A0, LOW);
      digitalWrite(WfmSrcSel1A1, LOW);
      digitalWrite(WfmSrcSel1A2, HIGH);
    }
    else if (source == "SIN1") {
      digitalWrite(WfmSrcSel1A0, HIGH);
      digitalWrite(WfmSrcSel1A1, LOW);
      digitalWrite(WfmSrcSel1A2, HIGH);
    }
    else if (source == "DAC0") {
      digitalWrite(WfmSrcSel1A0, LOW);
      digitalWrite(WfmSrcSel1A1, HIGH);
      digitalWrite(WfmSrcSel1A2, HIGH);
    }
    else if (source == "DAC1") {
      digitalWrite(WfmSrcSel1A0, HIGH);
      digitalWrite(WfmSrcSel1A1, HIGH);
      digitalWrite(WfmSrcSel1A2, HIGH);
    }
  }
}

// Expects channel and unsigned char for the new load.
void SetChLoad(char channel, unsigned char NewLoad) {
  ChConfig[channel - 1] = ConvertLoad(NewLoad);
  SendChConfig();
}

// Redundant functions to make it easier for David.
void SendCh1Load(unsigned char NewLoad) {
  SetChLoad(1, NewLoad);
}
void SendCh2Load(unsigned char NewLoad) {
  SetChLoad(2, NewLoad);
}
void SendCh3Load(unsigned char NewLoad) {
  SetChLoad(3, NewLoad);
}
void SendCh4Load(unsigned char NewLoad) {
  SetChLoad(4, NewLoad);
}

// Expects channel and unsigned char for the new electrode.
void SetChElectrode(char channel, unsigned char NewElectrode) {
  if (NewElectrode < 16) ChConfig[channel + 3] = NewElectrode + 8;
  else if (NewElectrode >= 16 && NewElectrode < 24) ChConfig[channel + 3] = NewElectrode + 16;
  SendChConfig();
}

void SetCh1Electrode(unsigned char NewElectrode) {
  SetChElectrode(1, NewElectrode);
}
void SetCh2Electrode(unsigned char NewElectrode) {
  SetChElectrode(2, NewElectrode);
}
void SetCh3Electrode(unsigned char NewElectrode) {
  SetChElectrode(3, NewElectrode);
}
void SetCh4Electrode(unsigned char NewElectrode) {
  SetChElectrode(4, NewElectrode);
}

// Old style simultaneous setting of all four channel loads and electrodes.

void SetChConfig(unsigned char* NewChConfig) {
  // First adjust values from input codes.
  for (char i = 0; i < 8; i++) {
    if (i >= 4) { // For Pin Numbers, bitshift as needed.
      //      NewChConfig[i] = NewChConfig[i] - 1; // This is now done in LabView.
      if (NewChConfig[i] < 16) ChConfig[i] = NewChConfig[i] + 8;
      else if (NewChConfig[i] >= 16 && NewChConfig[i] < 24) ChConfig[i] = NewChConfig[i] + 16;
    }
    else if (i < 4) { // Change number to bitshifted value for register.
      ChConfig[i] = ConvertLoad(NewChConfig[i]);
    }
  }
  SendChConfig();
}

// This does conversion from a load code to the needed signal.

unsigned char ConvertLoad(unsigned char InputCode) {
/*  switch (InputCode) {
    case 0: // This is for the electrode only.
      return 0b0001;
    case 1: // This is for the 10k resistor only.
      return 0b0010;
    case 2: // This is for the capacitor only.
      return 0b0100;
    case 3: // This is for the GND only.
      return 0b1000;
    case 7: // This is for electrode + 10k + capacitor.
      return 0b0111;
  }
  */
  return InputCode;
}

// Actually sends the current settings in ChConfig.
void SendChConfig() {
  // Check whether we are in the RUN state.
  if (stimulationstate == RUN) {
    // We form the serial data to clock out.
    byte dataout[6]; // This is the actual data clocked out.

    // Data format is.
    // Byte 0: 8-bit number for Stim4 Electrode Pin Number
    // Byte 1: 8-bit number for Stim3 Electrode Pin Number
    // Byte 2: 8-bit number for Stim2 Electrode Pin Number
    // Byte 3: 8-bit number for Stim1 Electrode Pin Number
    // Byte 4: 2 chars for CH4 and CH3 load.
    // Byte 5: 2 chars for CH2 and CH1 load.

    // Note on chars:
    // 0b0001 is Electrode (numerically 0)
    // 0b0010 is 10k Resistor (numerically 1)
    // 0b0100 is 10nF Capacitor (numerically 2)
    // 0b1000 is Ground (numerically 3)

    // So first we put the last four values from ChConfig into
    // the data to clock out, from Stim4 to Stim 1.


    dataout[0] = ChConfig[7];
    dataout[1] = ChConfig[6];
    dataout[2] = ChConfig[5];
    dataout[3] = ChConfig[4];

    // Next we take the now bitshifted versions of the Loads and
    // assemble them into the two remaining bytes.

    dataout[4] = (ChConfig[3] << 4) + ChConfig[2];
    dataout[5] = (ChConfig[1] << 4) + ChConfig[0];

    // For debugging, this is the 6 bytes sent in HEX.
    //    lcd2.setCursor(0, 1);
    //    lcd2.print("SPI:");
//    lcd2.setCursor(0, 1);
//    lcd2.print("Wfm 0 Hz: ");
//    lcd2.print(DDS0freq);
//    lcd2.setCursor(20, 1);
//    lcd2.print("Wfm 1 Hz: ");
//    lcd2.print(DDS1freq);

    // First just quickly print out what bytes are being sent.
    // This can be removed in the final version.
    for (int i = 0; i < 6; i++) {
      //      lcd2.print(" ");
      //      lcd2.print(dataout[i], HEX); // Print bytes being sent in order.
    }

    // And now we simply need to clock out these eight bytes one at
    // a time over SDATA1/SCK1, using the low-high transition for data valid.

    digitalWrite(SDATA1, LOW);
    digitalWrite(SCK1, LOW);
    digitalWrite(RCK1, LOW);
    digitalWrite(SCLR1, HIGH);
    digitalWrite(SCLR1, LOW);
    digitalWrite(SCLR1, HIGH);

    for (int i = 0; i < 6; i++) { // Loops through the six bits to send.
      for (int j = 7; j >= 0; j--) { // Loops through the bits from MSB to LSB.
        // The way this works is it takes the 8-bit byte to be sent
        // found in dataout[i]. (1 << j) is a bitshifted 1 in the location
        // of the bit to be sent. The & masks this over dataout[i] to remove
        // the other bits. Then it shifts it back to the LSB as either a
        // 0 or a 1, taken as LOW or HIGH. It then writes this out to
        // SDATA1.
        digitalWrite(SDATA1, (dataout[i] & (1 << j)) >> j);
        digitalWrite(SCK1, LOW); // This ensures that the data is stable by the low-high transition.
        digitalWrite(SCK1, HIGH);
      }
    }

    digitalWrite(RCK1, LOW);
    digitalWrite(RCK1, HIGH);   // Pulse Register Clock HIGH to transfer data from shift registers to output registers in IC 74HC595
    digitalWrite(RCK1, LOW);
  }
  else { // Otherwise, save the ChConfig state into the internal buffer.
    for (int i = 0 ; i < 8 ; i++) ChConfigSave[i] = ChConfig[i];
  }
}

// Sets the MDAC0 scaling output based on a floating point current.
void SetMDAC0(float current) {
  // Convert the float to an int so that 0-2 maps to 0-65535.
  unsigned int MDAC0int = 32767.5 * current;
  if (MDAC0int > 65535) {
    MDAC0int = 65535;
  }
  if (MDAC0int < 0 ) {
    MDAC0int = 0;
  }
  if ((stimulationstate == RUN) or (stimulationstate == DEBUG)) {
    SPI.setDataMode(SPI_MODE0); // SPI idle low, rising edge valid
    digitalWrite(MDAC0CS, LOW); // Set CS line for MDAC0.
    SPI.transfer((MDAC0int >> 8) & 0xFF); // Clock out MSByte
    SPI.transfer(MDAC0int & 0xFF); // Clock out LSByte
    digitalWrite(MDAC0CS, HIGH); // Unset CS line for MDAC0.
    lcd.setCursor(0, 1);
    lcd.print("Wfm 0 mA: ");
    lcd.print(current);
    Wfm0Current = current;
  }
  else Wfm0Save = current;
}

// Sets the MDAC1 scaling output based on a floating point current.
void SetMDAC1(float current) {
  // lcd.clear();
  // Convert the float to an int so that 0-2 maps to 0-65535.
  unsigned int MDAC1int = 32767.5 * current;
  if (MDAC1int > 65535) {
    MDAC1int = 65535;
  }
  if (MDAC1int < 0 ) {
    MDAC1int = 0;
  }
  if ((stimulationstate == RUN) or (stimulationstate == DEBUG)) {
    SPI.setDataMode(SPI_MODE0); // SPI idle low, rising edge valid
    digitalWrite(MDAC1CS, LOW); // Set CS line for MDAC0.
    SPI.transfer((MDAC1int >> 8) & 0xFF); // Clock out MSByte
    SPI.transfer(MDAC1int & 0xFF); // Clock out LSByte
    digitalWrite(MDAC1CS, HIGH); // Unset CS line for MDAC0.
    lcd.setCursor(20, 1);
    lcd.print("Wfm 1 mA: ");
    lcd.print(current);
    Wfm1Current = current;
  }
  else Wfm1Save = current; // If not outputting, save in register.
}

// More general function that ramps either MDAC based on the channel selected.

void RampMDAC(float startval, float endval, int period, char channel) {
  float deltaval = endval - startval; // Value change.
  int endtime = millis() + period; // Calculate End Time.
  if (channel == 0) {
    SetMDAC0(startval); // Set Initial Value.
    while ((millis() < endtime) && (endval - deltaval * (endtime - millis()) / period) > 0) { // Run for Period dcb 150718
      SetMDAC0(endval - deltaval * (endtime - millis()) / period);
    }
    SetMDAC0(endval); // Set final state.
  }
  if (channel == 1) {
    SetMDAC1(startval); // Set Initial Value.
    while ((millis() < endtime) && (endval - deltaval * (endtime - millis()) / period) > 0) { // Run for Period dcb 150718
      SetMDAC1(endval - deltaval * (endtime - millis()) / period);
    }
    SetMDAC1(endval); // Set final state. dcb 150718
  }
}

// And this one ramps both channels simultaneously.
void SimultaneousRampMDAC(float startval0, float endval0, float startval1, float endval1, int period) {
  int NumSteps = period / 10;
  float deltaTimePerStep = period / NumSteps;
  float deltaval0 = (endval0 - startval0) / NumSteps;
  float deltaval1 = (endval1 - startval1) / NumSteps;
  float MDAC0mA;
  float MDAC1mA;
  long ElapsedTime;
  SetMDAC0(startval0);
  SetMDAC1(startval1);
  long microsecStart = micros();
  for (int i = 0; i <= NumSteps; i++) {
    MDAC0mA = (startval0 + (i * deltaval0));
    MDAC1mA = (startval1 + (i * deltaval1));
//    lcd.setCursor(0, 1);
//    lcd.print("Wfm 0 mA: ");
//    lcd.print(MDAC0mA);
    SetMDAC0(MDAC0mA);
//    lcd.setCursor(20, 1);
//    lcd.print("Wfm 1 mA: ");
//    lcd.print(MDAC1mA);
    SetMDAC1(MDAC1mA);
    ElapsedTime = micros() - microsecStart;
    long thisLoopStart = microsecStart + i * 1000 * deltaTimePerStep;
    long timeInThisLoop = micros() - thisLoopStart;
    long timeTillNextLoop = 1000 * deltaTimePerStep - timeInThisLoop;
    delayMicroseconds(timeTillNextLoop);//long((period*1000)-ElapsedTime)/((i+1)*deltaTimePerStep)
  }
}

// Enters "Safe" Mode.
void SetModeSafe() {
  if (stimulationstate != SAFE) { // If it's already SAFE, do nothing.
    Wfm0Save = Wfm0Current;
    Wfm1Save = Wfm1Current; // Copy current MDAC outputs into buffer.
    SetMDAC0(0);
    SetMDAC1(0); // Wfm Current Amplitude set to 0.
    if (stimulationstate != DEBUG) { // If it coming from debug, don't need to fix loads.
      for (int i = 0 ; i < 8 ; i++) ChConfigSave[i] = ChConfig[i]; // Copy current channel config into buffer.
      SetChLoad(1, 2);
      SetChLoad(2, 2);
      SetChLoad(3, 2);
      SetChLoad(4, 2); // Set Loads to 10k Resistors.
    }
  }
  stimulationstate = SAFE; // Freeze in Safe Mode.
}

// Enters "Debug" Mode.

void SetModeDebug() {
  if (stimulationstate == RUN) { // If coming from SAFE or DEBUG, don't change load.
    for (int i = 0 ; i < 8 ; i++) ChConfigSave[i] = ChConfig[i]; // Copy current channel config into buffer.
    SetChLoad(1, 2);
    SetChLoad(2, 2);
    SetChLoad(3, 2);
    SetChLoad(4, 2); // Set Loads to 10k Resistors.
    Wfm0Save = Wfm0Current;
    Wfm1Save = Wfm1Current;
  }
  if (stimulationstate == SAFE) { // If coming from safe mode, restart current output.
    stimulationstate = DEBUG;
    SetMDAC0(Wfm0Save);
    SetMDAC1(Wfm1Save); // Recover Wfm Current Amplitudes
  }
  stimulationstate = DEBUG; // Freeze in Debug Mode.
}

void SetModeRun() {
  stimulationstate = RUN; // Set run state so functions will run commands.
  for (int i = 0 ; i < 8 ; i++) ChConfig[i] = ChConfigSave[i]; // Recover saved current channel config.
  SetMDAC0(Wfm0Save);
  SetMDAC1(Wfm1Save); // Recover Wfm Current Amplitudes
  SendChConfig(); // Resend Channel Configuration Data.
}

void RunPulse(int highperiod, int lowperiod, float highcurrent, float lowcurrent, int totalperiod, int repetitions) {
  // First, we will ensure that the electrodes are disconnected, but that the state is saved.

  // Copy current channel config into state buffer.
  for (int i = 0 ; i < 8 ; i++) ChConfigSave[i] = ChConfig[i];

  // Set Loads to 10k Resistors.
  SetChLoad(1, 2);
  SetChLoad(2, 2);
  SetChLoad(3, 2);
  SetChLoad(4, 2);

  // For speed in reloading the disconnected channel state, save this state as well.
  unsigned char ChConfigDisconnected[8];
  for (int i = 0 ; i < 8 ; i++) ChConfigDisconnected[i] = ChConfig[i];

  // Next, we will set the current output from the MDACs both to 2mA (full scale).
  // In this configuration, a DAC output of 1V will produce a 2mA output.
  SetMDAC0(2);
  SetMDAC1(2);

  // Next, we will configure the high and low outputs from the DACs.
  // Dividing the setpoint currents by 2 will provide a voltage to produce the proper current.
  SetDAC("A", highcurrent / 2);
  SetDAC("B", lowcurrent / 2);

  // We configure it so that DACA is the signal being output by the MDAC.
  SetWSS(0, "DACA");
  SetWSS(1, "DACA");

  for (int i = 0; i < repetitions; i++) { // After setup is complete, the following forms the core functionality.

    // The system is now configured with highcurrent mA connected to the 10k resistors.
    // We can now record the current time (resaved each loop).
    int endtime = millis() + totalperiod;

    // Next, we start the high pulse by reconnecting the electrode pins.
    SendChConfig(); // Send Channel Configuration Data.

    // And wait for the desired number of microseconds. This will require tuning to account for the fixed delay.
    delayMicroseconds(highperiod);

    // After the delay, we immediately switch the output to the low value output by DACB.
    SetWSS(0, "DACB");
    SetWSS(1, "DACB");

    // and now wait for the desired number of microseconds. This will require tuning to account for the fixed delay.
    delayMicroseconds(lowperiod);

    // After the delay, we will want to disconnect the electrodes first for speed.
    for (int i = 0 ; i < 8 ; i++) ChConfig[i] = ChConfigDisconnected[i]; // Recover disconnected current channel config.
    SendChConfig(); // Send Channel Configuration Data.

    // And then we can go ahead and preload the reconnect state (waiting to send until the next cycle).
    for (int i = 0 ; i < 8 ; i++) ChConfig[i] = ChConfigSave[i]; // Recover saved current channel config.

    // And wait until the next period starts.
    while (millis() < endtime); // Spin the wheels waiting for the next cycle to start.
  }
}
